uniform mat4 u_MVPMatrix;		// A constant representing the combined model/view/projection matrix.      		       
uniform mat4 u_MVMatrix;		// A constant representing the combined model/view matrix.
		  			
attribute vec4 a_Position;		// Per-vertex position information we will pass in.   				
//attribute vec4 a_Color;			// Per-vertex color information we will pass in.
attribute vec3 a_Normal;		// Per-vertex normal information we will pass in.
attribute vec2 a_TexCoordinate; // Per-vertex texture coordinate information we will pass in. 		
		  
varying vec4 v_Position;		// This will be passed into the fragment shader.
//varying vec4 v_Color;			// This will be passed into the fragment shader.
//varying vec3 v_Normal;			// This will be passed into the fragment shader.
varying vec2 v_TexCoordinate;   // This will be passed into the fragment shader.    		
		  
// The entry point for our vertex shader.  
void main()                                                 	
{      
  float radiusx;
  float radiusy;
  float radius;
  float x;
  float y;
  float z;
  float tmpY;
  float angle;
                              
	// Transform the vertex into eye space. 	
	v_Position = u_MVMatrix * a_Position;
	
	x = v_Position.x;
	y = v_Position.y;
	z = v_Position.z;
	radius = sqrt(x * x + y * y + z * z);
  radiusx = sqrt(x * x + z * z);
  radiusy = sqrt(y * y + z * z);
  x = acos(z / radiusx * -1.0) * radiusx * sign(x);
  // y = acos(abs(z) / radiusy) * radiusy * sign(y);
  // y = y * radius / radiusy;
  tmpY = y;
  y = y / radius * sqrt(radius * radius + (x) * (x)) ; 
  x = x / radius * sqrt(radius * radius + (tmpY) * (tmpY)) ; 
  v_Position.xyz = vec3(x, y, radius * -1.0);
	// Pass through the color.
	//v_Color = a_Color;
	
	// Pass through the texture coordinate.
	v_TexCoordinate = a_TexCoordinate;                                      
	
	// Transform the normal's orientation into eye space.
    //v_Normal = vec3(u_MVMatrix * vec4(a_Normal, 0.0));
          
	// gl_Position is a special variable used to store the final position.
	// Multiply the vertex by the matrix to get the final point in normalized screen coordinates.
	// gl_Position = u_MVPMatrix * a_Position;  
	gl_Position = u_MVPMatrix * v_Position;                      		  
}                                                          